<?php
session_start();
class Admin extends Controller {
    public function index(){
        try {
            if (!isset($_SESSION['user_role']) || $_SESSION['user_role'] !== 'admin') {
                throw new Exception("Unauthorized access.");
            }
            
            $data['book'] = $this->model('BookModel')->getAllBookAdmin();
            $data['author'] = $this->model('AuthorModel')->getAuthor();
        
            $this->view('admin/sidebar', $data);
        } catch (Exception $e) {
            $error_message = $e->getMessage();
            $this->view('error/403', ['error' => $error_message]);
        }
    }

    public function bookadmin(){
        try {
            if (!isset($_SESSION['user_role']) || $_SESSION['user_role'] !== 'admin') {
                throw new Exception("Unauthorized access.");
            }

            $data['book'] = $this->model('BookModel')->getAllBookAdmin();
            $data['author'] = $this->model('AuthorModel')->getAuthor();
        
            $this->view('admin/bookadmin', $data);
        } catch (Exception $e) {
            $error_message = $e->getMessage();
            $this->view('error/403', ['error' => $error_message]);
        }
    }

    public function useradmin(){
        try {
            if (!isset($_SESSION['user_role']) || $_SESSION['user_role'] !== 'admin') {
                throw new Exception("Unauthorized access.");
            }

            $data['user'] = $this->model('UserModel')->getAllUser();
            $this->view('admin/useradmin', $data);
        } catch (Exception $e) {
            $error_message = $e->getMessage();
            $this->view('error/403', ['error' => $error_message]);
        }
    }

    public function authoradmin(){
        try {
            if (!isset($_SESSION['user_role']) || $_SESSION['user_role'] !== 'admin') {
                throw new Exception("Unauthorized access.");
            }

            $data['authors'] = $this->model('AuthorModel')->getAllAuthor();
            $this->view('admin/authoradmin', $data);
        } catch (Exception $e) {
            $error_message = $e->getMessage();
            $this->view('error/403', ['error' => $error_message]);
        }
    }

    public function model($model){
        require_once '../app/models/' . $model . '.php';
        return new $model;
    }

    public function addBook(){
        if (isset($_SESSION['user_role']) && $_SESSION['user_role'] === 'admin' ){
            if ($_SERVER['REQUEST_METHOD'] === 'POST') {

                // Buat path image audio
                $imageDir = LOCALURL . "/img/";
                $audioDir = LOCALURL . "/audio/";
                // Ambil nilai
                $newTitle = $_POST["addTitle"];
                $selectedAuthor = $_POST["pickedAuthor"];
                $selectedCategory = $_POST["pickedCategory"];
                $newContent = $_POST["addContent"];
                $fileAudio = $_FILES['addAudio']['name'];
                $fileTmpAudio = $_FILES['addAudio']['tmp_name'];
                $fileImage = $_FILES['addImage']['name'];
                $fileTmpImage = $_FILES['addImage']['tmp_name'];
                $audioFilePath = $audioDir . $fileAudio;
                $imageFilePath = $imageDir . $fileImage;
                $data['book'] = $this->model('BookModel')->getAllBookAdmin();
                $data['author'] = $this->model('AuthorModel')->getAuthor();
                $array = array_column($data['book'], "title");

                // Cek exist ato g usernya, cek string kosong ato ngga
                if (!in_array($newTitle, $array, true) && !(empty($newTitle) || empty($newContent) || ( empty ($newTitle) && empty($newContent) ))){
                    $this->model('BookModel')->insertBook($newTitle, $newContent, $selectedAuthor, $selectedCategory);
                    move_uploaded_file($fileTmpAudio, $audioFilePath);
                    move_uploaded_file($fileTmpImage, $imageFilePath);
                }
                
            }
            $data['book'] = $this->model('BookModel')->getAllBookAdmin();
            $data['author'] = $this->model('AuthorModel')->getAuthor();
            $this->view('admin/bookadmin', $data);
        } else {
            $this->view('error/404');
        }
    }
    public function addUser(){
        if (isset($_SESSION['user_role']) && $_SESSION['user_role'] === 'admin' ){
            if ($_SERVER['REQUEST_METHOD'] === 'POST') {
                try {
                    $newUsername = $_POST['newUsername'];
                    $newPassword = $_POST['newPassword'];
                    $data['user'] = $this->model('UserModel')->getAllUser();
                    $array = array_column($data['user'], "username");

                    // Cek stringnya kosong ato g && exist ato g usernya 
                    if (empty($newUsername) || empty($newPassword)) {
                        throw new Exception("Username and Password cannot be empty.");
                    }

                    if (in_array($newUsername, $array, true)) {
                        throw new Exception("Username already exists.");
                    }

                    $this->model('UserModel')->insertUser($newUsername, $newPassword);
                } catch (Exception $e) {
                    // Handle the error, you can redirect or display a message
                    $error_message = $e->getMessage();
                    $data['user'] = $this->model('UserModel')->getAllUser();
                    $this->view('admin/useradmin', ['error' => $error_message] + $data);
                    return;
                }
            }
            $data['user'] = $this->model('UserModel')->getAllUser();
            $this->view('admin/useradmin', $data);
        } else {
            $this->view('error/404');
        }
    }

    public function editBook(){
        if (isset($_SESSION['user_role']) && $_SESSION['user_role'] === 'admin') {
            if ($_SERVER['REQUEST_METHOD'] === 'POST') {


                // Buat path image audio
                $imageDir = LOCALURL . "/img/";
                $audioDir = LOCALURL . "/audio/";
                // Ambil nilai
                $newTitle = $_POST["newTitle"];
                $oldTitle = $_POST["oldTitle"];
                $selectedAuthor = $_POST["selectedAuthor"];
                $selectedCategory = $_POST["selectedCategory"];
                $newContent = $_POST["newContent"];
                $bookid = $_POST["bookid"];

                $fileAudio = $_FILES['audio']['name'];
                $fileTmpAudio = $_FILES['audio']['tmp_name'];
                $fileImage = $_FILES['image']['name'];
                $fileTmpImage = $_FILES['image']['tmp_name'];
                $audioFilePath = $audioDir . $fileAudio;
                $imageFilePath = $imageDir . $fileImage;

                $data['book'] = $this->model('BookModel')->getAllBook();
                $array = array_column($data['book'], "title");
                // Cek title kosong atau udah exist di db atau gk diganti
                if(!empty($newTitle) && (!in_array($newTitle, $array, true) || $newTitle === $oldTitle) && (isset($fileAudio) && isset($fileImage))){
                    $this->model('BookModel')->updateBook($bookid, $newTitle, $selectedAuthor, $newContent, $selectedCategory);
                    move_uploaded_file($fileTmpAudio, $audioFilePath);
                    move_uploaded_file($fileTmpImage, $imageFilePath);
                }

                $data['book'] = $this->model('BookModel')->getAllBookAdmin();
                $data['author'] = $this->model('AuthorModel')->getAuthor();
                $this->view('admin/bookadmin', $data);

            }
        } else{
            $this->view('error/404');
        }
    }

    public function editUser(){
        if (isset($_SESSION['user_role']) && $_SESSION['user_role'] === 'admin') {
            if ($_SERVER['REQUEST_METHOD'] === 'POST') {
                try {
                    // Dapetin nilai dari input formnye ya
                    $oldUsername = $_POST['username'];
                    $newUsername = $_POST['newUsername'];
                    $newPassword = $_POST['newPassword'];
                    $userId = $_POST['userId'];
                    $data['user'] = $this->model('UserModel')->getAllUser();
                    // Bikin kolom array list username buat pengecekkan
                    $array = array_column($data['user'], "username");

                    // Cek password kosong dan user kosong atau udah exist di db atau gk diganti
                    if (empty($newUsername) || empty($newPassword)) {
                        throw new Exception("Username and Password cannot be empty.");
                    }

                    if (in_array($newUsername, $array, true) && $newUsername !== $oldUsername) {
                        throw new Exception("Username already exists.");
                    }

                    $this->model('UserModel')->updateUser($userId, $newUsername, $newPassword);
                } catch (Exception $e) {
                    // Handle the error, you can redirect or display a message
                    $error_message = $e->getMessage();
                    $data['user'] = $this->model('UserModel')->getAllUser();
                    $this->view('admin/useradmin', ['error' => $error_message] + $data);
                    return;
                }
            }
            $data['user'] = $this->model('UserModel')->getAllUser();
            $this->view('admin/useradmin', $data);
        }
        else {
            $this->view('login/login');
        }
    }
    public function addAuthor(){
        if (isset($_SESSION['user_role']) && $_SESSION['user_role'] === 'admin' ){
            if ($_SERVER['REQUEST_METHOD'] === 'POST') {
                try {
                    $newAuthorName = $_POST['newAuthorName'];

                    $data['authors'] = $this->model('AuthorModel')->getAllAuthor();
                    $authorNames = array_column($data['authors'], "author_name");

                    // Cek exist atau kosong
                    if (empty($newAuthorName)) {
                        throw new Exception("Author name cannot be empty.");
                    }

                    if (in_array($newAuthorName, $authorNames, true)) {
                        throw new Exception("Author name already exists.");
                    }

                    $this->model('AuthorModel')->insertAuthor($newAuthorName);
                } catch (Exception $e) {
                    // Handle the error, you can redirect or display a message
                    $error_message = $e->getMessage();
                    $data['authors'] = $this->model('AuthorModel')->getAllAuthor();
                    $this->view('admin/authoradmin', ['error' => $error_message] + $data);
                    return;
                }
            }

            $data['authors'] = $this->model('AuthorModel')->getAllAuthor();
            $this->view('admin/authoradmin', $data);
        } else {
            $this->view('login/login');
        }
    }

    public function editAuthor(){
        if (isset($_SESSION['user_role']) && $_SESSION['user_role'] === 'admin') {
            if ($_SERVER['REQUEST_METHOD'] === 'POST') {
                try {
                    $newAuthorName = $_POST['newAuthorName'];
                    $oldAuthorName = $_POST['authorName'];
                    $authorid = $_POST['authorId'];

                    $data['authors'] = $this->model('AuthorModel')->getAllAuthor();
                    $authorNames = array_column($data['authors'], "author_name");

                    // Cek exist atau kosong
                    if (empty($newAuthorName)) {
                        throw new Exception("Author name cannot be empty.");
                    }

                    if (in_array($newAuthorName, $authorNames, true) && $newAuthorName !== $oldAuthorName) {
                        throw new Exception("Author name already exists.");
                    }

                    $this->model('AuthorModel')->updateAuthor($authorid, $newAuthorName);
                } catch (Exception $e) {
                    // Handle the error, you can redirect or display a message
                    $error_message = $e->getMessage();
                    $data['authors'] = $this->model('AuthorModel')->getAllAuthor();
                    $this->view('admin/authoradmin', ['error' => $error_message] + $data);
                    return;
                }
            }

            $data['authors'] = $this->model('AuthorModel')->getAllAuthor();
            $this->view('admin/authoradmin', $data);
        } else {
            $this->view('login/login');
        }
    }

    public function deleteAuthor(){
        if (isset($_SESSION['user_role']) && $_SESSION['user_role'] === 'admin') {
            if ($_SERVER['REQUEST_METHOD'] === 'POST') {
                try {
                    $authorId = $_POST['deleteId'];
                    $this->model('AuthorModel')->deleteAuthor($authorId);
                } catch (Exception $e) {
                    // Handle the error, you can redirect or display a message
                    $error_message = $e->getMessage();
                    $data['authors'] = $this->model('AuthorModel')->getAllAuthor();
                    $this->view('admin/authoradmin', ['error' => $error_message] + $data);
                    return;
                }
            }

            $data['authors'] = $this->model('AuthorModel')->getAllAuthor();
            $this->view('admin/authoradmin', $data);
        } else {
            $this->view('login/login');
        }
    }

    public function deleteUser(){
        if (isset($_SESSION['user_role']) && $_SESSION['user_role'] === 'admin') {
            if ($_SERVER['REQUEST_METHOD'] === 'POST') {
                try {
                    $userId = $_POST['deleteId'];
                    $this->model('UserModel')->deleteUser($userId);
                } catch (Exception $e) {
                    // Handle the error, you can redirect or display a message
                    $error_message = $e->getMessage();
                    $data['user'] = $this->model('UserModel')->getAllUser();
                    $this->view('admin/useradmin', ['error' => $error_message] + $data);
                    return;
                }
            }

            $data['user'] = $this->model('UserModel')->getAllUser();
            $this->view('admin/useradmin', $data);
        } else {
            $this->view('login/login');
        }
    }
    public function deleteBook(){
        if (isset($_SESSION['user_role']) && $_SESSION['user_role'] === 'admin') {
            if ($_SERVER['REQUEST_METHOD'] === 'POST') {
                try {
                    $bookId = $_POST['deleteId']; 
                    $this->model('BookModel')->deleteBook($bookId);
                } catch (Exception $e) {
                    // Handle the error, you can redirect or display a message
                    $error_message = $e->getMessage();
                    $data['book'] = $this->model('BookModel')->getAllBookAdmin();
                    $data['author'] = $this->model('AuthorModel')->getAuthor();
                    $this->view('admin/bookadmin', ['error' => $error_message] + $data);
                    return;
                }
            }
            $data['book'] = $this->model('BookModel')->getAllBookAdmin();
            $data['author'] = $this->model('AuthorModel')->getAuthor();
            $this->view('admin/bookadmin', $data);
        } else {
            $this->view('login/login');
        }
    }
    
    
}