<?php

class App {

    protected $controller;
    protected $method;

    protected $params = [];
    public function __construct(){

        
        // require_once ('../app/controllers/Defaultx.php');
        $this->controller = 'Defaultx';
        $this->method = 'index';

        $url = $this->parseURL();
        // Index pertama adalah controller, kedua adalah metode. Intinya ini cari
        // Ada controller sesuai url user gak? kalau ada bakal ditimpa. Kalau gak,
        // Masih default (dinamain defaultx karena default doang gak bisa).
        $isControllerNull = $url[0] ?? null;
        if( isset($isControllerNull) && file_exists('../app/controllers/' . $url[0] . '.php' ) )
        {
            $this->controller = $url[0];
            // Unset itu buat ngilangin controllernya dari array
            // jadi url[0] deleted, tapi gk geser jadi tetep ada
            // di index ke-1, dst kalau ada.
            unset($url[0]);
        }

        // Dari IF ini, kalau ada controller udah ditentuin

        require_once '../app/controllers/' . $this->controller . '.php';
        $this->controller = new $this->controller;

        // Baik default atau non default, controller telah di set.

        // Sekarang cari metode dalem controller
        if( isset($url[1]) ){
            if(method_exists($this->controller, $url[1]) ){
                // kalau ada, ditimpa yang tadinya by default, index
                $this->method = $url[1];
                // buang lagi di index 1, metode diambil.
                unset($url[1]);
            }
        }

        // ini lanjut cari parameters
        if (!empty($url)){
            // Ngambil values dalam array, yaitu parameters
            $this->params = array_values($url);
        }

        // Jalanin controller & method, +kirim params kalo ada
        call_user_func_array([$this->controller, $this->method], $this->params);
    }

    public function parseURL(){
        if ( isset($_GET['url']) ){
            $url = rtrim($_GET['url'], '/'); // Ngapus / terakhir
            $url = filter_var($url, FILTER_SANITIZE_URL); // Filtering URLnya dari karakter2 aneh
            $url = explode('/', $url);
            return $url;
        }
    }
}