<?php

class Tables
{
    public const AUTHOR_TABLE =
    "CREATE TABLE IF NOT EXISTS author (
        id INT AUTO_INCREMENT PRIMARY KEY,
        name VARCHAR(255) UNIQUE NOT NULL
    );";
    public const USER_TABLE =
    "CREATE TABLE IF NOT EXISTS user(
        id INT AUTO_INCREMENT PRIMARY KEY,
        username VARCHAR(20) UNIQUE NOT NULL,
        password VARCHAR(255) NOT NULL,
        admin BOOLEAN NOT NULL
    );";

    public const BOOK_TABLE =
    "CREATE TABLE IF NOT EXISTS book (
        id INT AUTO_INCREMENT PRIMARY KEY,
        title VARCHAR(256) UNIQUE NOT NULL,
        content TEXT NOT NULL,
        author_id INT NOT NULL,
        audio_path VARCHAR(256) NOT NULL,
        image_path VARCHAR(256) NOT NULL,
        category VARCHAR(256) NOT NULL,
        FOREIGN KEY(author_id) REFERENCES author(id) ON DELETE CASCADE

    );";

    public const INVENTORY_TABLE =
    "CREATE TABLE IF NOT EXISTS inventory (
        user_id INT NOT NULL,
        book_id INT NOT NULL,
        FOREIGN KEY (user_id) REFERENCES user(id) ON DELETE CASCADE,
        FOREIGN KEY (book_id) REFERENCES book(id) ON DELETE CASCADE
    );";
}