
<?php
class BookModel
{
    private $table = 'book';
    private $database;

    public function __construct()
    {
        $this->database = new Database;
    }
    public function getAllBook(){
        $this->database->query('SELECT * FROM book');
        return $this->database->resultSet();
    }

    public function getAllBookAdmin(){
        $this->database->query('SELECT book.id, title, content, author.name, audio_path, image_path, category FROM book JOIN author on book.author_id = author.id');
        return $this->database->resultSet();
    }

    public function tambahDataAuthor(){
        $query = "INSERT INTO author
                    VALUES
                    ('', Jack)";
        $this->database->query($query);
        $this->database->execute();
    }
    public function tambahDataBuku(){
        $query = "INSERT INTO buku
                    VALUES
                    ('', Title1, 1, url_audio, url_image, cat1)";
        $this->database->query($query);
        $this->database->execute();
    }

    public function getCategory(){
        $this->database->query('SELECT DISTINCT category FROM book');
        return $this->database->resultSet();
    }

    public function insertBook($newTitle, $newContent, $pickedAuthor, $pickedCategory){
        $this->database->query('INSERT IGNORE INTO book (id, title, content, author_id, audio_path, image_path, category) VALUES (NULL, :newTitle, :newContent, (SELECT id FROM author WHERE author.name = :pickedAuthor), :newAudio, :newImage, :pickedCategory)');
        $newAudio = "audioex.mp3";
        $newImage = "imageex.png";
        $this->database->bind('newTitle', $newTitle);
        $this->database->bind('newContent', $newContent);
        $this->database->bind('newAudio', $newAudio);
        $this->database->bind('newImage', $newImage);
        $this->database->bind('pickedAuthor', $pickedAuthor);
        $this->database->bind('pickedCategory', $pickedCategory);
        $this->database->execute();
    }
    public function updateBook($bookid, $newTitle, $selectedAuthor, $newContent, $selectedCategory){
        $this->database->query('UPDATE book SET title = :newTitle, content = :newContent, author_id = (SELECT id FROM author WHERE author.name = :selectedAuthor), category = :newCategory WHERE book.id = :bookid');
        $this->database->bind('bookid', $bookid);
        $this->database->bind('newTitle', $newTitle);
        $this->database->bind('newContent', $newContent);
        $this->database->bind('selectedAuthor', $selectedAuthor);
        $this->database->bind('newCategory', $selectedCategory);
        $this->database->execute();
    }

    public function deleteBook($id){
        $query = "DELETE FROM book WHERE id = :id";
        $this->database->query($query);
        $this->database->bind('id',$id);
        $this->database->execute();
        return 1;
    }
    public function getAllBookmark($limit, $offset){
        $this->database->query("SELECT book.id, title, author.name, category, audio_path, image_path FROM book JOIN author ON book.author_id = author.id JOIN inventory ON book.id = inventory.book_id JOIN user ON user.id = inventory.user_id WHERE user.id = :id LIMIT $limit OFFSET $offset");
        $this->database->bind('id', $_SESSION['id']);
        return $this->database->resultSet();
    }
    public function getAllBookList($limit, $offset){
        $this->database->query("SELECT book.id, title, author.name, category, audio_path, image_path FROM book JOIN author ON book.author_id = author.id LIMIT $limit OFFSET $offset");
        return $this->database->resultSet();
    }
    public function getBookDetail($id){
        $this->database->query("SELECT book.id, title, author.name, category FROM book JOIN author ON book.author_id = author.id WHERE book.id = :id");
        $this->database->bind('id', $id);
        return $this->database->single();
    }
    public function addBookmark($id, $bookid){
        // Check if the tuple exists
        $this->database->query("SELECT * FROM inventory WHERE user_id = :id AND book_id = :bookid");
        $this->database->bind('id', $id);
        $this->database->bind('bookid', $bookid);
        $this->database->execute();
        $existingTuple = $this->database->single();
    
        if (!$existingTuple) {
            // The tuple doesn't exist, so insert it
            $this->database->query("INSERT INTO inventory (user_id, book_id) VALUES (:id, :bookid)");
            $this->database->bind('id', $id);
            $this->database->bind('bookid', $bookid);
            $this->database->execute();
        } 
    }
    
    public function deleteBookmark($id, $bookid){
        $this->database->query("DELETE FROM inventory WHERE user_id = :id AND book_id = :bookid");
        $this->database->bind('id', $id);
        $this->database->bind('bookid', $bookid);
        $this->database->execute();
    }
    public function getBookFilename($id){
        $this->database->query("SELECT audio_path, image_path FROM book WHERE id = :id");
        $this->database->bind('id', $id);
        return $this->database->single();
    }
    public function getAllBookFilename(){
        $this->database->query("SELECT audio_path, image_path FROM book");
        return $this->database->resultSet();
    }

    public function searchBookmark($searchInput, $sortSelect, $sortOrder, $filterSelect, $filterQuery, $limit, $offset){
        // Construct the SQL query based on the provided parameters
        $sql = "SELECT book.id, title, author.name, category, audio_path, image_path FROM book JOIN author ON book.author_id = author.id JOIN inventory ON book.id = inventory.book_id JOIN user ON user.id = inventory.user_id WHERE 1=1"; // Initial WHERE condition
    
        if ($filterSelect && $filterQuery) {
            $sql .= " AND $filterSelect = '$filterQuery'";
        }
    
        if ($searchInput) {
            // Sanitize the search input to prevent SQL injection
            // $searchInput = mysqli_real_escape_string($this->database->getConnection(), $searchInput);
            
            // Create a search query using LIKE clause for substring search
            $sql .= " AND (title LIKE '%$searchInput%' OR author.name LIKE '%$searchInput%')";
        }
    
        if ($sortSelect != "none") {
            // Check for valid sort order (ASC or DESC)
            if ($sortOrder === 'ascending') {
                $sortOrder = 'ASC';
            } elseif ($sortOrder === 'descending') {
                $sortOrder = 'DESC';
            } else {
                // Default to ascending if sortOrder is not valid
                $sortOrder = 'ASC';
            }
            if ($sortSelect = "author"){
                $sortSelect = "author.name";
            }
    
            $sql .= " ORDER BY $sortSelect $sortOrder";
        }
        $sql .= " LIMIT $limit OFFSET $offset";
        // Execute the query and return the results
        $this->database->query($sql);
        return $this->database->resultSet();
    }
    public function searchBookList($searchInput, $sortSelect, $sortOrder, $filterSelect, $filterQuery, $limit, $offset){
        // Construct the SQL query based on the provided parameters
        $sql = "SELECT book.id, title, author.name, category, audio_path, image_path FROM book JOIN author ON book.author_id = author.id WHERE 1=1"; // Initial WHERE condition
    
        if ($filterSelect && $filterQuery) {
            $sql .= " AND $filterSelect = '$filterQuery'";
        }
    
        if ($searchInput) {
            // Sanitize the search input to prevent SQL injection
            // $searchInput = mysqli_real_escape_string($this->database->getConnection(), $searchInput);
            
            // Create a search query using LIKE clause for substring search
            $sql .= " AND (title LIKE '%$searchInput%' OR author.name LIKE '%$searchInput%')";
        }
    
        if ($sortSelect != "none") {
            // Check for valid sort order (ASC or DESC)
            if ($sortOrder === 'ascending') {
                $sortOrder = 'ASC';
            } elseif ($sortOrder === 'descending') {
                $sortOrder = 'DESC';
            } else {
                // Default to ascending if sortOrder is not valid
                $sortOrder = 'ASC';
            }
            if ($sortSelect = "author"){
                $sortSelect = "author.name";
            }
            $sql .= " ORDER BY $sortSelect $sortOrder";
        }
        $sql .= " LIMIT $limit OFFSET $offset";
        
        // Execute the query and return the results
        $this->database->query($sql);
        return $this->database->resultSet();
    }
    public function pageCount()
    {
        $this->database->query('SELECT COUNT(*) FROM book JOIN inventory ON book.id = inventory.book_id JOIN user ON user.id = inventory.user_id');
        $count = $this->database->single(); // Assuming you have a method like singleColumn()

        // Convert the count value to an integer
        $count = intval($count);

        return $count;
    }

}