<?php

class UserModel
{   
    private $table = 'user';
    private $database;

    public function __construct()
    {
        $this->database = new Database;
    }

    public function getAllUser(){
        $this->database->query('SELECT * FROM user WHERE admin = 0');
        return $this->database->resultSet();
    }

    public function getAllUsername(){
        $this->database->query('SELECT username FROM user WHERE admin = 0');
        return $this->database->resultSet();
    }
    public function getUserByUsername($username){
        $this->database->query('SELECT * FROM ' . $this->table . ' WHERE username = :username' . ' AND admin = 0');
        $this->database->bind('username', $username);
        return $this->database->single();
    }
    public function getAdminByUsername($username){
        $this->database->query('SELECT * FROM ' . $this->table . ' WHERE username = :username' . ' AND admin = 1');
        $this->database->bind('username', $username);
        return $this->database->single();
    }

    public function updateUser($userId, $newUsername, $newPassword){
        $this->database->query('UPDATE ' . $this->table . ' SET username = :newUsername, password = :newPassword WHERE id = :userId');
        $this->database->bind('newUsername', $newUsername);
        $this->database->bind('newPassword', $newPassword); // Hash the new password
        $this->database->bind('userId', $userId);
        $this->database->execute();
    }

    public function insertUser($newUsername, $newPassword){
        $this->database->query('INSERT IGNORE INTO user (id, username, password, admin) VALUES (NULL, :newUsername, :newPassword, 0)');
        $this->database->bind('newUsername', $newUsername);
        $this->database->bind('newPassword', $newPassword);
        $this->database->execute();
    }
    public function deleteUser($id){
        $this->database->query('DELETE FROM user WHERE id = :id');
        $this->database->bind('id', $id);
        $this->database->execute();
    }
}