<!DOCTYPE html>

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title> Admin Page </title>
    <link rel="stylesheet" href="<?php echo BASEURL; ?>/style/sidebar.css">
    <link rel="stylesheet" href="<?php echo BASEURL; ?>/style/authoradmin.css">
    <link href='https://fonts.googleapis.com/css?family=Italianno' rel='stylesheet'>
    <link href='https://fonts.googleapis.com/css?family=Hanuman' rel='stylesheet'>
    <link href='https://unpkg.com/boxicons@2.0.9/css/boxicons.min.css' rel='stylesheet'>
</head>

<body>
    <?php
    include(__DIR__ . '/sidebar.php');
    ?>

    <div class="top-section">
        <h1 class="title">Authors</h1>
        <button class="add-btn" onclick="openAddPopup()">Add Author</button>
    </div>

    <div class="overlay" id="overlay"></div>
    <div style="overflow-x: auto;">
        <table id="users">
            <!-- Judul-judul kolom -->
            <thead>
                <tr>
                    <th>ID</th>
                    <th>Name</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>
                <?php foreach ($data['authors'] as $row) : ?>
                    <?php
                    $id = $row['id'];
                    $name = $row['name'];

                    ?>
                    <tr>
                        <td><?php echo $id; ?></td>
                        <td><?php echo $name; ?></td>
                        <td>
                            <button class="edituser" onclick="editAuthor('<?php echo $name; ?>', '<?php echo $id;?>')">
                                Edit
                            </button>
                            <button class="deleteuser" onclick="deleteAuthor('<?php echo $id ?>')">
                                Delete
                            </button>
                        </td>
                        <div class="edit-popup" id="editpopup">
                            <form id="editForm" method="post" action='<?php echo BASEURL; ?>/admin/editAuthor'>
                                <input type="hidden" id="authorid" name="authorId">
                                <input type="hidden" id="oldauthor" name="authorName">
                                <div class="add-input">
                                    <input type="text" id="username" name="newAuthorName" placeholder="Enter new username.." required>
                                </div>
                            </form>
                            <div class="add-submission">
                                <button type="submit" class="submit-button" onclick="submitForm()">Submit</button>
                                <button class="cancel-button" onclick="closeEditPopup()">Cancel</button>
                            </div>
                        </div>


                        <div class="delete-popup" id="deletepopup">
                            <p>
                                Are you sure want to delete this author?
                            </p>
                            <form id="deleteForm" method="post" action='<?php echo BASEURL; ?>/admin/deleteAuthor'>
                                <input type="hidden" id = "deleteid" name="deleteId">
                            </form>
                            <div class="add-submission">
                                <button class="submit-button" onclick="deleteForm()">Delete</button>
                                <button class="cancel-button" onclick=closeDeletePopup()>Cancel</button>
                            </div>
                        </div>

                    </tr>
                <?php endforeach ?>
            </tbody>
        </table>
    </div>

    <div class="add-popup" id="addpopup">
        <form id="addForm" method="post" action='<?php echo BASEURL; ?>/admin/addAuthor'>
            <div class="add-input">
                <input type="text" id="username" name="newAuthorName" placeholder="Enter new username.." required>
            </div>
        </form>
        <div class="add-submission">
            <button type="submit" class="submit-button" onclick="addForm()">Submit</button>
            <button class="cancel-button" onclick="closeAddPopup()">Cancel</button>
        </div>
    </div>

    <script src="<?php echo BASEURL; ?>/js/authoradmin.js"></script>
</body>

</html>