<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name = "viewport" content="width=device-width, initial-scale=1.0">
    <title> Book List</title>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.2/css/all.min.css" crossorigin="anonymous" referrerpolicy="no-referrer" />
    <link href='https://fonts.googleapis.com/css?family=Italianno' rel='stylesheet'>
    <link href='https://fonts.googleapis.com/css?family=Hanuman' rel='stylesheet'>
    <link rel ="stylesheet" href="<?php echo BASEURL ?>/style/detailbook.css">
</head>
<body>
    <?php
    
    // Check if the 'book' key exists in $data
    if (isset($data['book'])) {
        // Access the values using the correct keys
        $bookid = $data['book']['id'];
        $title = $data['book']['title'];
        $author = $data['book']['name'];
        $category = $data['book']['category'];
        $username = $_SESSION['username'];
        $id = $_SESSION['id'];
        $imgPath = $data['path']['image_path'];
        $audioPath = $data['path']['audio_path'];
        
        
        // Echo the values from $data into the HTML template
        ?>
        
        <a class="back-button" href="<?php echo BASEURL; ?>/user/index"><i class="fas fa-arrow-left"></i> Back</a>


        <h1 class="book-title"><?php echo $title; ?></h1>
        <div class="line"></div>
        <div class="container">
            <div class="content">
                <div class="picture">
                    <img src="<?php echo BASEURL ?>/img/<?php echo $imgPath ?>">
                </div>
                <div class="audio">
                    <audio controls>
                        <source src="<?php echo BASEURL ?>/audio/<?php echo $audioPath ?>" type="audio/mp3">
                        Gagal
                    </audio>
                </div>
            </div>
            <div class="right-content">
                <div class="author">
                    Author: <?php echo $author; ?>
                </div>
                <div class="category">
                    Category: <?php echo $category; ?>
                </div>
                <p>Kemudian daripada itu untuk membentuk suatu Pemerintah Negara Indonesia yang melindungi segenap bangsa Indonesia dan seluruh tumpah darah Indonesia dan untuk memajukan kesejahteraan umum, mencerdaskan kehidupan bangsa, dan ikut melaksanakan ketertiban dunia yang berdasarkan kemerdekaan, perdamaian abadi dan keadilan sosial, maka disusunlah Kemerdekaan Kebangsaan Indonesia itu dalam suatu Undang-Undang Dasar Negara Indonesia, yang terbentuk dalam suatu susunan Negara Republik Indonesia yang berkedaulatan rakyat dengan berdasar kepada Ketuhanan Yang Maha Esa, Kemanusiaan yang adil dan beradab, Persatuan Indonesia dan Kerakyatan yang dipimpin oleh hikmat kebijaksanaan dalam Permusyawaratan/Perwakilan, serta dengan mewujudkan suatu Keadilan sosial bagi seluruh rakyat Indonesia.</p>
                <form action="<?php echo BASEURL; ?>/user/addbookmark/" method="post">
                    <input type="hidden" name="id" value="<?php echo $id; ?>">
                    <input type="hidden" name="bookid" value="<?php echo $bookid; ?>">
                    <button type="submit" class="bookmark">Add to Bookmark</button>
                </form>

            </div>
        </div>
        <?php
    } else {
        // Handle the case where $data['book'] is not set or empty
        echo "No book data available.";
    }
    ?>
    <!-- Include your JavaScript or other content here -->
</body>
</html>
